routes/web.php
<?php

use App\Http\Controllers\ApplicationsController;
use App\Http\Controllers\BooksController;
use App\Http\Controllers\MainPageController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [App\Http\Controllers\CategoriesController::class, 'index'])->name('home');

Route::resource('categories', \App\Http\Controllers\CategoriesController::class)->only(['index', 'show']);

Route::get('main', [MainPageController::class, 'index'])->name('main');

Route::resource('books', BooksController::class)->only(['show']);

Route::resource('books.applications', ApplicationsController::class)->only(['create', 'store']);

Route::get('/users/register', [App\Http\Controllers\UsersController::class,
    'register'])->name('users.register');
Route::post('users', [App\Http\Controllers\UsersController::class, 'store'])
    ->name('users.store');
Route::get('/login', [App\Http\Controllers\SessionsController::class, 'create'])
    ->name('sessions.login');
Route::post('/login', [App\Http\Controllers\SessionsController::class, 'store'])
    ->name('sessions.store');
Route::delete('/logout', [App\Http\Controllers\SessionsController::class, 'destroy'])
    ->name('sessions.delete');

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Category extends Model
{
    use HasFactory;

    /**
     * @var string[]
     */
    protected $fillable = ['genre'];

    /**
     * @return HasMany
     */
    public function books(): HasMany
    {
        return $this->hasMany(Book::class);
    }
}

app/Http/Controllers/CategoriesController.php
<?php

namespace App\Http\Controllers;

use App\Models\Book;
use App\Models\Category;
use Illuminate\Http\Request;

class CategoriesController extends Controller
{
    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function index()
    {
        $categories = Category::all();
        $books = Book::paginate(6);
        return view('categories.index', compact('categories', 'books'));
    }

    /**
     * @param Category $category
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function show(Category $category)
    {
        $books = Book::all()->where('category_id', $category->id);
        return view('categories.show', compact('category', 'books'));
    }
}

resources/views/categories/index.blade.php
@extends('layouts.base')

@section('content')
    @include('notifications.alerts')
    <div class="container">
        <div class="col-6">
            <div class="row">
                <div class="col-2">
                    <h3>Genres</h3>
                </div>
            </div>
        </div>
    </div>

    @foreach($categories as $category)
        <a href="{{route('categories.show', ['category' => $category])}}"><h3>{{$category->genre}}</h3></a>
        <div class="container">
            <div class="row row-cols-1 row-cols-md-2 row-cols-lg-3 justify-content-center">
                @foreach($books as $book)
                    @if($category->id == $book->category_id)
                        <div class="d-flex col mb-3">
                            <div class="card">
                                <div class="card-img">
                                    <img src="{{asset('/storage/' . $book->picture)}}" class="card-img-top" alt="{{$book->picture}}">
                                </div>
                                <div class="card-body d-flex flex-column">
                                    <a href="{{route('books.show', ['book' => $book])}}"><b>{{$book->title}}</b></a>
                                    <p class="card-text">{{$book->author}}</p>
                                        <form id="create-application" action="{{route('books.applications.create', ['book' => $book])}}">
                                                @if($book->status == 'get')
                                                <button type="submit" class="btn btn-outline-primary btn-sm btn-block" role="button"
                                                        aria-pressed="true">Get</button>
                                            @else
                                                <p>Expected date: {{$book->return_date}}</p>
                                            @endif
                                    </form>
                                </div>
                            </div>
                        </div>
                    @endif
                @endforeach
            </div>
        </div>
    @endforeach

    <div class="row justify-content-md-center p-5">
        <div class="col-md-auto">
            {{ $books->links('pagination::bootstrap-4') }}
        </div>
    </div>

@endsection

resources/views/categories/show.blade.php
@extends('layouts.base')

@section('content')

    <div class="container">
        <div>
            <h1>{{$category->genre}}</h1>
        </div>

        <div class="mt-3 mb-3">
            <a href="{{route('categories.index')}}" type="button" class="btn btn-outline-primary">
                <b>Back</b>
            </a>
        </div>

            <div class="container">
                <div class="row row-cols-1 row-cols-md-2 row-cols-lg-3 justify-content-center">
                    @foreach($category->books as $book)

                            <div class="d-flex col mb-3">
                                <div class="card">
                                    <div class="card-img">
                                        <img src="{{asset('/storage/' . $book->picture)}}" class="card-img-top" alt="{{$book->picture}}">
                                    </div>
                                    <div class="card-body d-flex flex-column">
                                        <h5 class="card-title"><b>{{$book->title}}</b></h5>
                                        <p class="card-text">{{$book->author}}</p>
                                        <div class="mt-auto" id="{{$book->id}}">
                                            <a href="{{route('applications.create', ['application' => $application])}}" class="btn btn-primary"><b>Get</b></a>
                                            <button class="btn btn-primary btn-add-to-cart"><b>Get</b></button>
                                        </div>
                                    </div>

                                </div>
                            </div>

                    @endforeach
                </div>
            </div>
    </div>

@endsection